ACT_KAPI_ROLL = allocate_mario_action(ACT_FLAG_ATTACKING | ACT_FLAG_MOVING | ACT_GROUP_MOVING | MARIO_KICKING)

ACT_KAPI_ROLL_FALL = allocate_mario_action(ACT_FLAG_ATTACKING | ACT_FLAG_MOVING | ACT_GROUP_AIRBORNE | ACT_FLAG_AIR)

ACT_KAPI_ROLL_AIR = allocate_mario_action(ACT_FLAG_ATTACKING | ACT_FLAG_MOVING | ACT_GROUP_AIRBORNE | ACT_FLAG_AIR )

ACT_KAPI_DASH = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ATTACKING | ACT_FLAG_MOVING | ACT_FLAG_DIVING)

ACT_KAPI_TWIRL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_WATER_OR_TEXT)

ACT_KAPI_WALL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING)

ACT_KAPI_LONG_JUMP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING)

ACT_KAPI_JUMP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING)

ACT_KAPI_DASH_CANCEL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING)

ACT_KAPI_HIGH_JUMP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING)

ACT_KAPI_AIR_JUMP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING)

ACT_KAPI_FREEFALL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING) 

ACT_KAPI_KB = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_SHORT_HITBOX)

ACT_KAPI_WALKING = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_WATER_OR_TEXT)

ACT_KAPI_HURT = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_MOVING | ACT_FLAG_INVULNERABLE)

gStateExtras = {}
for i = 0, (MAX_PLAYERS - 1) do
    gStateExtras[i] = {}
    local e = gStateExtras[i]
    e.rotAngle = 0
    e.animFrame = 0
    e.camLock = false
    e.rollSound = 0
    e.twirlMomemtum = 0
end



local s16 = function(x)

    x = (math.floor(x) & 0xFFFF)

    if x >= 32768 then return x - 65536 end
    return x
end

local function act_kapi_walking(m)
  local e = gStateExtras[m.playerIndex]
  
  local stepResult = perform_ground_step(m)
  
  apply_slope_accel(m)
  
  local StickRot = atan2s(m.controller.stickY, m.controller.stickX)
  local Mag = (m.controller.stickMag)/64
  local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)
  
  if stepResult == GROUND_STEP_LEFT_GROUND then
    m.vel.y = 0
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
  elseif stepResult == GROUND_STEP_NONE then
    if m.heldObj ~= nil then
      set_mario_anim_with_accel(m, MARIO_ANIM_WALK_WITH_LIGHT_OBJ, m.forwardVel * 0x3000)
            play_step_sound(m, 1, 28)
            if m.controller.buttonPressed & B_BUTTON ~= 0 then
            set_mario_action(m, ACT_THROWING, 0)
              if e.camLock == true then
                m.faceAngle.y = gLakituState.yaw + 0x8000
              end
            elseif m.controller.buttonPressed & Z_TRIG ~= 0 then
              set_mario_action(m, ACT_KAPI_KB, 0)
              mario_throw_held_object(m)
              end
            else
              if m.forwardVel < 40 then
              set_mario_anim_with_accel(m, CHAR_ANIM_RUNNING_UNUSED, m.forwardVel*0x2000)
              else
                set_mario_anim_with_accel(m, CHAR_ANIM_RUNNING, m.forwardVel*0x3000)
                end
              play_step_sound(m, 12, 62)
    end
    
    if should_begin_sliding(m) ~= 0 then

        if m.heldObj == nil then
            return set_mario_action(m, ACT_BEGIN_SLIDING, 0)
        else
            return set_mario_action(m, ACT_HOLD_BEGIN_SLIDING, 0)
        end
        m.squishTimer = 5
        m.particleFlags = PARTICLE_MIST_CIRCLE
    end
    
  elseif stepResult == GROUND_STEP_HIT_WALL then
    mario_set_forward_vel(m, 5)
    set_mario_anim_with_accel(m, CHAR_ANIM_RUNNING_UNUSED, m.forwardVel*0x1500)
    
  end
  
  if m.controller.buttonDown & Z_TRIG ~= 0 and m.heldObj == nil then
    return set_mario_action(m, ACT_KAPI_ROLL, 0)
    end
  
  if m.controller.buttonPressed & A_BUTTON ~= 0 then
      m.vel.y = 45
      set_mario_action(m, ACT_KAPI_JUMP, 0)
    elseif (m.controller.buttonPressed & Z_TRIG ~= 0) then
      if m.heldObj ~= nil then
        m.heldObj.oForwardVel = 55
        m.heldObj.oVelY = 35
        m.heldObj.oPosY = m.pos.y + 50
        if m.playerIndex == 0 and e.camLock == true then
                m.faceAngle.y = gLakituState.yaw + 0x8000
                m.heldObj.oFaceAngleYaw = gLakituState.yaw + 0x8000
        end
              mario_throw_held_object(m)
        end
      m.actionTimer = 0
      set_mario_action(m, ACT_KAPI_ROLL, 0)
      m.squishTimer = 7
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE | PARTICLE_VERTICAL_STAR
    audio_sample_play(kapiroll, m.pos , 2.5)
  audio_sample_play(kapirolling, m.pos, 2.5)
    m.vel.y = -20
    m.forwardVel = 55
    e.rollSound = 0
    end
  
  if m.forwardVel > 70 then
    m.marioObj.header.gfx.angle.x = 0x2500
    else
  m.marioObj.header.gfx.angle.x = 0x0 + 0x1000*m.forwardVel/30
  end
  
      if (m.input & INPUT_ZERO_MOVEMENT) ~= 0 then

        mario_set_forward_vel(m, approach_f32(m.forwardVel, 0, 10, 10))

        if math.abs(m.forwardVel) < 2 then
            if m.heldObj ~= nil then
                return set_mario_action(m, ACT_HOLD_IDLE, 0)
            else
                return set_mario_action(m, ACT_IDLE, 0)
            end
        end
      end
  
  if m.forwardVel > 40 then
    m.particleFlags = PARTICLE_DUST
  end
  
  if m.controller.stickMag ~= 0 and (m.input & INPUT_ABOVE_SLIDE) == 0 then
    mario_set_forward_vel(m, approach_f32(m.forwardVel, (Mag*35), 5, 0.75))
  end
  
  if m.playerIndex == 0 then
    if e.camLock == false then
  m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x1500, 0x1500)
    else
      m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x2000, 0x2000)
    m.marioObj.header.gfx.angle.y = gLakituState.yaw + 0x8000
    end
    end
  
  m.actionTimer = m.actionTimer + 1
  
  end

local function act_kapi_roll(m)
  local e = gStateExtras[m.playerIndex]
  
  local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)
  local StickRot = atan2s(m.controller.stickY, m.controller.stickX)
  
  if m.actionTimer == 0 and m.prevAction ~= ACT_KAPI_ROLL_FALL and m.prevAction ~= ACT_KAPI_ROLL_LAND then
    m.squishTimer = 7
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE | PARTICLE_VERTICAL_STAR
    audio_sample_play(kapiroll, m.pos , 2.5)
  audio_sample_play(kapirolling, m.pos, 2.5)
    m.vel.y = -20
    m.forwardVel = 45
    e.rollSound = 0
    e.rotAngle = 0x0
    e.animFrame = 0
  end
  
  if m.playerIndex == 0 then
  if e.rollSound < 43 then
    e.rollSound = e.rollSound + 1
    else
      e.rollSound = 0
      audio_sample_play(kapirolling, m.pos, 2.5)
  end
  end
  
  if m.flags & MARIO_METAL_CAP ~= 0 then
    m.particleFlags = PARTICLE_FIRE
    end
  
  if m.input & INPUT_ABOVE_SLIDE == 0 then
  mario_set_forward_vel(m, approach_s32(m.forwardVel, 70, 5, 1))
  end
  
  if m.forwardVel < 130 then
      apply_slope_decel(m, 0.3)
      apply_slope_accel(m)
      else
  mario_set_forward_vel(m, m.forwardVel - 5)
  end
  if m.forwardVel < 30 then
    set_mario_action(m, ACT_BEGIN_SLIDING, 0)
    m.squishTimer = 5
  end

step = perform_ground_step(m)

if step == GROUND_STEP_LEFT_GROUND then
  set_mario_action(m, ACT_KAPI_ROLL_FALL, 0)
  e.rollSound = 42
elseif
 step == GROUND_STEP_HIT_WALL then
    set_mario_action(m, ACT_KAPI_KB, 0)
    audio_sample_play(kapicrashwall, m.pos, 1)
 end
  
  set_mario_animation(m, CHAR_ANIM_FORWARD_SPINNING)
    set_anim_to_frame(m, e.animFrame)
    e.animFrame = e.animFrame + 2
    
    if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            e.animFrame = 0
        end
 
 if m.playerIndex == 0 then
    if e.camLock == false then
  m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x1000, 0x1000)
    else
    m.faceAngle.y = gLakituState.yaw + 0x8000
    end
    
 end
    
    if m.controller.buttonDown & Z_TRIG == 0 and m.actionTimer > 5 then
      set_mario_action(m, ACT_KAPI_WALKING, 0)
      audio_sample_stop(kapirolling)
    end
    
    m.actionTimer = m.actionTimer + 1
    
end

local function act_kapi_roll_fall(m)
  local e = gStateExtras[m.playerIndex]
  
  if m.actionTimer == 1 then
    m.vel.y = 0
    m.actionTimer = 2
    e.animFrame = 0
  end
  
  m.vel.y = m.vel.y - 1

common_air_action_step(m, ACT_KAPI_ROLL, CHAR_ANIM_FORWARD_SPINNING, AIR_STEP_NONE)
set_anim_to_frame(m, e.animFrame)
    e.animFrame = e.animFrame + 2
    
    if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            e.animFrame = 0
        end
  
  if m.playerIndex == 0 then  
    if e.camLock == false then
    if m.controller.stickMag ~= 0 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else
    m.faceAngle.y = m.faceAngle.y
  end
    else
    m.faceAngle.y = gLakituState.yaw + 0x8000
    end
    end
    
    if m.controller.buttonDown & Z_TRIG == 0 then
      set_mario_action(m, ACT_KAPI_FREEFALL, 0)
    end
    
    end




local function act_kapi_roll_air(m)
 local e = gStateExtras[m.playerIndex] 
  
  if m.actionTimer == 0 and m.prevAction ~= ACT_KAPI_ROLL then
    m.particleFlags = PARTICLE_MIST_CIRCLE | PARTICLE_VERTICAL_STAR
    e.rollSound = 42
    audio_sample_play(kapiroll, m.pos , 2.5)
    m.faceAngle.y = m.intendedYaw
    else
      m.particleFlags = PARTICLE_SPARKLES
      if m.playerIndex == 0 then 
  if e.camLock == false then
  if m.forwardVel > 1 then
    if m.controller.stickMag > 0 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else
    m.faceAngle.y = m.faceAngle.y
    end
  else
   m.faceAngle.y = m.faceAngle.y + 0x8000
  end
  else
    m.faceAngle.y = gLakituState.yaw + 0x8000
  end
 end
  end
  
  if m.playerIndex == 0 then
        if mario_check_object_grab(m) ~= 0 and m.heldObj == nil then
            mario_grab_used_object(m)
            if m.interactObj.behavior == get_behavior_from_id(id_bhvBowser) then
                m.marioBodyState.grabPos = GRAB_POS_BOWSER
                set_mario_action(m, ACT_PICKING_UP_BOWSER, 0)
                return 1
            elseif m.interactObj.oInteractionSubtype & INT_SUBTYPE_GRABS_MARIO ~= 0 then
                m.marioBodyState.grabPos = GRAB_POS_HEAVY_OBJ
                set_mario_action(m, ACT_PICKING_UP, 0)
                return 1
            else
                m.marioBodyState.grabPos = GRAB_POS_LIGHT_OBJ
                set_mario_action(m, ACT_KAPI_WALKING, 0)
                m.squishTimer = 5
                return 1
            end
        end
    end
  
  m.forwardVel = 50
  m.vel.y = -65
  
 step = common_air_action_step(m, ACT_KAPI_ROLL, CHAR_ANIM_SLIDE_DIVE, AIR_STEP_NONE)
 
 if step == AIR_STEP_LANDED then
   if m.controller.stickMag > 0 then
   set_mario_action(m, ACT_KAPI_ROLL, 0)
   else
     set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
     m.squishTimer = 10
   m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR | PARTICLE_MIST_CIRCLE
   audio_sample_play(kapicrashwall, m.pos, 1)
   end
end
  
  m.marioObj.header.gfx.angle.x = m.marioObj.header.gfx.angle.x + 0x2048
  if m.controller.buttonDown & Z_TRIG == 0 and m.actionTimer > 5 then
      set_mario_action(m, ACT_KAPI_FREEFALL, 0)
  end
  
  m.actionTimer = m.actionTimer + 1
  return
  end


local function act_kapi_dash(m)
  local e = gStateExtras[m.playerIndex]

    local spinDirFactor = 1
    local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)
     
     if m.playerIndex == 0 then
        if mario_check_object_grab(m) ~= 0 and m.heldObj == nil then
            mario_grab_used_object(m)
            if m.interactObj.behavior == get_behavior_from_id(id_bhvBowser) then
                m.marioBodyState.grabPos = GRAB_POS_BOWSER
                set_mario_action(m, ACT_PICKING_UP_BOWSER, 0)
                return 1
            elseif m.interactObj.oInteractionSubtype & INT_SUBTYPE_GRABS_MARIO ~= 0 then
                m.marioBodyState.grabPos = GRAB_POS_HEAVY_OBJ
                return 1
            else
                m.marioBodyState.grabPos = GRAB_POS_LIGHT_OBJ
                return 1
            end
        end
    end
     
    if m.actionTimer == 0 then 
      audio_sample_play(kapidash, m.pos , 2.5)
    e.rotAngle = 0x0
    if m.forwardVel < 45 then
      mario_set_forward_vel(m, 45)
      end
      end
    if m.heldObj == nil then
      common_air_action_step(m, ACT_WALKING, CHAR_ANIM_SLIDE_DIVE, AIR_STEP_NONE)
      else
        
        if m.heldObj.oInteractionSubtype & INT_SUBTYPE_GRABS_MARIO ~= 0 then
    common_air_action_step(m, ACT_PICKING_UP, CHAR_ANIM_SLIDE_DIVE, AIR_STEP_NONE)
    else
      common_air_action_step(m, ACT_DIVE_PICKING_UP, CHAR_ANIM_SLIDE_DIVE, AIR_STEP_NONE)

        end
        
  end
  
   if m.playerIndex == 0 then 
   if e.camLock == false then
    if m.controller.stickMag ~= 0 and m.forwardVel > -1 then
  m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x750, 0x750)
  else
    m.faceAngle.y = m.faceAngle.y
    end
    else
    m.faceAngle.y = gLakituState.yaw + 0x8000
   end
   end

  if m.actionTimer > 20 then
    if m.heldObj == nil then
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
    end
  end
  
  if m.actionTimer < 10 then
    mario_set_forward_vel(m, approach_s32(m.forwardVel, 55, 7.5, 7.5))
    m.vel.y = 0
    e.rotAngle = e.rotAngle + 0x2400
    if e.rotAngle > 0x24000 then 
      e.rotAngle = 0x0
    end
    else
      e.rotAngle = 0
      end
    
    m.marioObj.header.gfx.angle.z = m.marioObj.header.gfx.angle.z + e.rotAngle
  
  m.actionTimer = m.actionTimer + 1
  return
end



local function act_kapi_twirl(m)
  local e = gStateExtras[m.playerIndex]

    local spinDirFactor = 1 
    if m.actionState == 1 then spinDirFactor = -1 end
  if m.playerIndex == 0 then
  if m.actionTimer == 0 then
    if gPlayerSyncTable[0].ACT_FLAG_TWIRL_BOOST ~= 0 then
    m.vel.y = 45
    m.forwardVel = m.forwardVel/1.25
    else
      m.forwardVel = m.forwardVel/50
      m.vel.y = 10
    end
    gPlayerSyncTable[0].ACT_FLAG_TWIRL_BOOST = 0
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
    m.squishTimer = 2
    audio_sample_play(kapitwirl, m.pos, 2.5)
    if m.flags & MARIO_WING_CAP ~= 0 then
      mario_set_forward_vel(m, m.forwardVel*1.05)
      m.faceAngle.x = 0x1250
      return set_mario_action(m, ACT_FLYING, 0)
    end
end
end

  common_air_action_step(m, ACT_WALKING, CHAR_ANIM_FLY_FROM_CANNON, AIR_STEP_NONE)
vec3f_set(m.marioBodyState.headAngle, 0x3000, 0, 0)
vec3f_set(m.marioBodyState.headPos, 0, 10, 0)

  if m.vel.y < -15 then
    m.vel.y = -15 else
      m.vel.y = m.vel.y - 0.6
  end
  
  if m.forwardVel > 25 then
    m.forwardVel = m.forwardVel - 0.6
    else
      m.forwardVel = m.forwardVel + 0.6
      end
  
  if m.controller.buttonDown & A_BUTTON == 0 and m.actionTimer > 3 then
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
  end
  
  if m.forwardVel > 5 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else m.faceAngle.y = m.intendedYaw
  end
  
  if m.forwardVel > 35 then
  e.rotAngle = e.rotAngle + 0x10*(m.forwardVel*15)
  else
    e.rotAngle = e.rotAngle + 0x1000
    end
    if e.rotAngle >  0x10000 then 
      e.rotAngle = e.rotAngle - 0x10000 
      audio_sample_play(kapitwirl, m.pos, 2.5)
   m.particleFlags = PARTICLE_DUST
    end
    
    
    m.marioObj.header.gfx.angle.x = ((m.forwardVel/35)*0x1000)-0x4000
  
  m.marioObj.header.gfx.angle.z = m.marioObj.header.gfx.angle.z + e.rotAngle
  
  m.actionTimer = m.actionTimer + 1
  return 
  end



local function act_kapi_wall(m)
 local e = gStateExtras[m.playerIndex] 

    if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
        local rc = set_mario_action(m, ACT_KAPI_JUMP, 0)
        audio_sample_play(kapiwalljump, m.pos , 2.5)
        m.forwardVel = 20
        m.wallKickTimer = 0
        m.faceAngle.y = m.faceAngle.y + 0x8000
        return rc
    end
    
    m.particleFlags = m.particleFlags | PARTICLE_DUST

     play_sound(SOUND_MOVING_TERRAIN_SLIDE + m.terrainSoundAddend, m.marioObj.header.gfx.cameraToObject)

 if m.wall ~= nil then m.faceAngle.y = atan2s(m.wall.normal.z, m.wall.normal.x) + 0x8000
   end

    mario_set_forward_vel(m, 1)

    set_mario_animation(m, MARIO_ANIM_CLIMB_UP_POLE)

    if perform_air_step(m, 0) == AIR_STEP_LANDED then
        mario_set_forward_vel(m, 0)
        if check_fall_damage_or_get_stuck(m, ACT_HARD_BACKWARD_GROUND_KB) == 0 then
            return set_mario_action(m, ACT_FREEFALL_LAND, 0)
        end
    end

    m.actionTimer = m.actionTimer + 1
    if m.wall == nil and m.actionTimer > 2 then
        mario_set_forward_vel(m, 0.0)
        return set_mario_action(m, ACT_KAPI_FREEFALL, 0)
    end
    if gPlayerSyncTable[0].KAPI_WALLJUMP_COUNTER < 10 then
    m.vel.y = m.vel.y + 3.5-(gPlayerSyncTable[0].KAPI_WALLJUMP_COUNTER)
    end
    m.peakHeight = m.pos.y
end



local function act_kapi_long_jump(m)
  local e = gStateExtras[m.playerIndex]
  
  if m.actionTimer == 0 then
    audio_sample_play(kapilongjump, m.pos , 2.5)
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
    e.rotAngle = 0x0
    m.vel.y = 55
    m.squishTimer = 2
  end
  if m.actionTimer < 12 then
  common_air_action_step(m, ACT_KAPI_WALKING, CHAR_ANIM_TRIPLE_JUMP, AIR_STEP_NONE)
  else
  common_air_action_step(m, ACT_IDLE, CHAR_ANIM_FLY_FROM_CANNON, AIR_STEP_NONE)
  end
  
 if m.playerIndex == 0 then 
  if e.camLock == true then
    m.faceAngle.y = gLakituState.yaw + 0x8000
    else
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  end
  end
  
 if e.rotAngle < 0x10216 then
   e.rotAngle = e.rotAngle + 0x1024
   else
     end
  
   m.marioObj.header.gfx.angle.x = m.marioObj.header.gfx.angle.x + e.rotAngle
   
   if m.actionTimer == 30 then
     set_mario_action(m, ACT_KAPI_FREEFALL, 0)
     end
  
  m.actionTimer = m.actionTimer + 1
  return
end

local function act_kapi_high_jump(m)
  local e = gStateExtras[m.playerIndex]
  
  if m.actionTimer == 0 then
    e.animFrame = 0
    m.pos.y = m.pos.y + 10
    m.squishTimer = 5
    audio_sample_play(kapihighjump, m.pos , 2.5)
    end
  if m.actionTimer < 4 then
    m.forwardVel = 0
    m.vel.y = 0
    set_mario_animation(m, CHAR_ANIM_START_CROUCHING)
  elseif m.actionTimer == 4 then
    m.vel.y = 65
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
  elseif m.actionTimer > 20 then
    common_air_action_step(m, ACT_KAPI_WALKING, CHAR_ANIM_BACKFLIP, AIR_STEP_NONE)
    set_anim_to_frame(m, e.animFrame)
    e.animFrame = e.animFrame + 2
  else
  common_air_action_step(m, ACT_KAPI_WALKING, CHAR_ANIM_DOUBLE_JUMP_RISE, AIR_STEP_NONE)
  end
  
  if m.actionTimer == 28 then
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
    end
  
if m.playerIndex == 0 then  
  if e.camLock == false then
    m.faceAngle.y = m.intendedYaw
    else
    m.faceAngle.y = gLakituState.yaw + 32768
  end
  end
  
  m.actionTimer = m.actionTimer + 1
  return
  end

local function act_kapi_jump(m)
  local e = gStateExtras[m.playerIndex]
  
  local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)
  
  if m.controller.stickMag == 0 and m.forwardVel > 0 then
   m.forwardVel = m.forwardVel - 5
  end
 
 mario_set_forward_vel(m, approach_s32(m.forwardVel, 0, 1, 0.5))
  
  if m.actionTimer == 0 then
    m.squishTimer = 2
    audio_sample_play(kapijump, m.pos , 5)
    if m.prevAction == ACT_KAPI_WALL then
      if gPlayerSyncTable[0].KAPI_WALLJUMP_COUNTER < 7 then
      m.vel.y = -(1.5^(gPlayerSyncTable[0].KAPI_WALLJUMP_COUNTER)) + 60
      else
        m.vel.y = 1
        m.forwardVel = 35
        m.particleFlags = PARTICLE_VERTICAL_STAR
      end
      else
    m.vel.y = 45
    end
  end
  
  if m.heldObj == nil then
  common_air_action_step(m, ACT_KAPI_WALKING, CHAR_ANIM_DOUBLE_JUMP_RISE, AIR_STEP_NONE)
  else
     if (m.controller.buttonPressed & Z_TRIG ~= 0) then
       set_mario_action(m, ACT_KAPI_ROLL_FALL, 0)
        m.heldObj.oForwardVel = 55
        m.heldObj.oVelY = 35
        m.heldObj.oPosY = m.pos.y + 50
        if m.playerIndex == 0 and e.camLock == true then
                m.faceAngle.y = gLakituState.yaw + 0x8000
                m.heldObj.oFaceAngleYaw = gLakituState.yaw + 0x8000
        end
              mario_throw_held_object(m)
              end
    common_air_action_step(m, ACT_KAPI_WALKING, CHAR_ANIM_JUMP_WITH_LIGHT_OBJ, AIR_STEP_NONE)
  end
  
    if m.playerIndex == 0 then
      if (m.forwardVel > 5 and e.camLock ~= true) or m.prevAction == ACT_KAPI_WALL then
 m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x1500, 0x1500)
  else m.faceAngle.y = m.intendedYaw
      end
end
  
  m.actionTimer = m.actionTimer + 1
  return
end

local function act_kapi_dash_cancel(m)
  local e = gStateExtras[m.playerIndex]
  
  if m.actionTimer == 0 then
    audio_sample_play(kapidashcancel, m.pos , 2.5)
   m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
    e.rotAngle = 0x0
    m.squishTimer = 3
    m.vel.y = 45
    m.forwardVel = 55
  end
  common_air_action_step(m, ACT_FREEFALL_LAND, CHAR_ANIM_TWIRL, AIR_STEP_NONE)
  
  if m.actionTimer < 12 then
  set_mario_animation(m, CHAR_ANIM_RIDING_SHELL)
  else
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
  end
  
  if m.playerIndex == 0 then
  if e.camLock == true then
    m.faceAngle.y = gLakituState.yaw + 32768
    else
  if m.forwardVel > 5 then
  m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
  else m.faceAngle.y = m.intendedYaw
  end
  end
  end
  m.marioObj.header.gfx.angle.y = m.marioObj.header.gfx.angle.y + e.rotAngle
  
  if e.rotAngle < 0x16000 then
   e.rotAngle = e.rotAngle + 0x2000
   else
     end
  
  m.actionTimer = m.actionTimer + 1
  return
end

local function act_kapi_air_jump(m)
  local e = gStateExtras[m.playerIndex]
  
  if m.actionTimer == 0 then
    audio_sample_play(kapiairjump, m.pos , 2.5)
    e.rotAngle = 0x10216
  end
  common_air_action_step(m, ACT_KAPI_WALKING, CHAR_ANIM_TWIRL, AIR_STEP_NONE)
  if m.actionTimer < 12 then
  set_mario_animation(m, CHAR_ANIM_FLY_FROM_CANNON)
  else
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
  end
  
  if m.playerIndex == 0 then
  if e.camLock == true then
    m.faceAngle.y = gLakituState.yaw + 32768
    else
      if m.controller.stickMag > 0 then
      m.faceAngle.y = atan2s(m.vel.z, m.vel.x)
      else
        m.faceAngle.y = m.faceAngle.y
        end
  end
  end
  
  if m.actionTimer < 2 and m.action == ACT_KAPI_AIR_JUMP then
    m.vel.y = 0
    m.forwardVel = 0
    else
  if e.rotAngle > 0x0 then
   e.rotAngle = e.rotAngle - 0x2048
   else
  end
  m.marioObj.header.gfx.angle.y = m.marioObj.header.gfx.angle.y - e.rotAngle
  end
  if m.actionTimer == 2 then
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
    m.forwardVel = 65
    m.vel.y = 30
    end
   
   m.actionTimer = m.actionTimer + 1
   return
end
 
 
 
 local function act_kapi_freefall(m)
   local e = gStateExtras[m.playerIndex]
   
   local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)
   
   mario_set_forward_vel(m, approach_f32(m.forwardVel, 0, 0.5, 0.5))
 
 if m.heldObj == nil then
   if m.prevAction == ACT_KAPI_JUMP and m.forwardVel > 45 then
     common_air_action_step(m, ACT_KAPI_WALKING, CHAR_ANIM_DOUBLE_JUMP_FALL, AIR_STEP_NONE)
     else
  common_air_action_step(m, ACT_KAPI_WALKING, CHAR_ANIM_DOUBLE_JUMP_FALL, AIR_STEP_NONE)
  end
  else
    if (m.controller.buttonPressed & Z_TRIG ~= 0) then
       set_mario_action(m, ACT_KAPI_ROLL_FALL, 0)
        m.heldObj.oForwardVel = 55
        m.heldObj.oVelY = 35
        m.heldObj.oPosY = m.pos.y + 50
        if m.playerIndex == 0 and e.camLock == true then
                m.faceAngle.y = gLakituState.yaw + 0x8000
                m.heldObj.oFaceAngleYaw = gLakituState.yaw + 0x8000
        end
              mario_throw_held_object(m)
              end
    common_air_action_step(m, ACT_KAPI_WALKING, CHAR_ANIM_JUMP_WITH_LIGHT_OBJ, AIR_STEP_NONE)
    end
 
 if m.controller.stickMag == 0 and m.forwardVel > 0 then
   m.forwardVel = m.forwardVel - 5
   end
 
 if m.playerIndex == 0 then
 if e.camLock == true then
    m.marioObj.header.gfx.angle.y = gLakituState.yaw + 32768
    m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x2500, 0x2500)
    else
 if m.forwardVel > 5 then
  m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x1500, 0x1500)
  else m.faceAngle.y = m.intendedYaw
 end
end
end

m.actionTimer = m.actionTimer + 1 return
 end
 
 local function act_kapi_kb(m)
   local e = gStateExtras[m.playerIndex]
   
   if m.actionTimer == 1 then
     m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
     mario_set_forward_vel(m, -10)
     m.vel.y = 50
     m.squishTimer = 7
   end
   
   if m.actionTimer > 8 then
     set_mario_action(m, ACT_KAPI_FREEFALL, 0)
     end
   step = perform_air_step(m, 0)
   
   if step == AIR_STEP_LANDED then
     m.vel.y = 50
     mario_set_forward_vel(m, -5)
     end
   
   set_mario_animation(m, CHAR_ANIM_BACKFLIP)
   
   m.faceAngle.y = m.intendedYaw
   
   m.actionTimer = m.actionTimer + 1
   
 end
 
 function act_kapi_hurt(m)
   
   local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)
   
    if m.actionTimer == 1 then
    if m.actionArg == 1 then mario_set_forward_vel(m, 25) else
      mario_set_forward_vel(m, -15)
      end
     m.vel.y = 40
     m.invincTimer = 3
    end
 
 m.vel.y = m.vel.y + 1.8
   
   if m.vel.y < -5 and m.actionTimer > 10 then
     set_mario_action(m, ACT_KAPI_FREEFALL, 0)
    mario_set_forward_vel(m, m.forwardVel)
     end
   step = perform_air_step(m, 0)
   
   if step == AIR_STEP_LANDED then
     m.vel.y = 50
     mario_set_forward_vel(m, -5)
     end
   
   set_mario_anim_with_accel(m, CHAR_ANIM_SHOCKED, 0x7500)
   m.marioBodyState.eyeState = MARIO_EYES_DEAD
   
   m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x250, 0x250)
   
   if m.actionTimer < 5 and m.marioObj.header.gfx.angle.x > -0x3500 then
     m.marioObj.header.gfx.angle.x = m.marioObj.header.gfx.angle.x - 0x1500
     else
   m.marioObj.header.gfx.angle.x = -0x3500*(m.vel.y/40)
   end
   
   m.actionTimer = m.actionTimer + 1
  if m.health < 0x100 then
    set_mario_action(m, ACT_HARD_BACKWARD_AIR_KB, 0)
    end
   
   end

hook_mario_action(ACT_KAPI_ROLL, act_kapi_roll, INT_GROUND_POUND)
hook_mario_action(ACT_KAPI_ROLL_FALL, { every_frame = act_kapi_roll_fall }, INT_GROUND_POUND)
hook_mario_action(ACT_KAPI_ROLL_AIR, { every_frame = act_kapi_roll_air }, INT_GROUND_POUND)
hook_mario_action(ACT_KAPI_WALL, { every_frame = act_kapi_wall })
hook_mario_action(ACT_KAPI_DASH, act_kapi_dash, INT_FAST_ATTACK_OR_SHELL)
hook_mario_action(ACT_KAPI_TWIRL, { every_frame = act_kapi_twirl })
hook_mario_action(ACT_KAPI_LONG_JUMP, { every_frame = act_kapi_long_jump })
hook_mario_action(ACT_KAPI_HIGH_JUMP, { every_frame = act_kapi_high_jump })
hook_mario_action(ACT_KAPI_JUMP, { every_frame = act_kapi_jump })
hook_mario_action(ACT_KAPI_DASH_CANCEL, { every_frame = act_kapi_dash_cancel })
hook_mario_action(ACT_KAPI_AIR_JUMP, { every_frame = act_kapi_air_jump })
hook_mario_action(ACT_KAPI_FREEFALL, { every_frame = act_kapi_freefall})
hook_mario_action(ACT_KAPI_KB, {every_frame = act_kapi_kb})
hook_mario_action(ACT_KAPI_WALKING, act_kapi_walking)
hook_mario_action(ACT_KAPI_HURT, act_kapi_hurt)