-- name: \\#87889D\\Kapi's \\#40B6E4\\Moveset \\#ffff50\\v2
-- description: This mod lets you play with the moveset of Kapi from the roblox game "Kapi's Rock n' Roll"! \\n\\ \\#60ff60\\Compatible both with Character Select and standalone! \\#ffffff\\For standalone type "/kapi" to toggle
-- category: moveset

gPlayerSyncTable[0].ACT_FLAG_CAN_DASH = 1

gPlayerSyncTable[0].ACT_FLAG_CAN_ROLL_VARIATE = 1

gPlayerSyncTable[0].ACT_FLAG_TWIRL_BOOST = 1

gPlayerSyncTable[0].KAPI_WALLJUMP_COUNTER = 0

E_MODEL_KAPI = smlua_model_util_get_id("kapi_geo")

TEX_HUD_KAPI = get_texture_info("hud_kapi")

gPlayerSyncTable[0].isKapi = false

gPlayerSyncTable[0].CanHurtSound = true

kapijump = audio_sample_load("Kapijump.ogg")
kapiroll = audio_sample_load("Kapiroll.ogg")
kapidash = audio_sample_load("Kapidash.ogg")
kapidashcancel = audio_sample_load("Kapidashcancel.ogg")
kapilongjump = audio_sample_load("Kapilongjump.ogg")
kapihighjump = audio_sample_load("Kapihighjump.ogg")
kapiwalljump = audio_sample_load("Kapiwalljump.ogg")
kapitwirl = audio_sample_load("Kapitwirl.ogg")
kapiairjump = audio_sample_load("Kapiairjump.ogg")
kapiattack = audio_sample_load("Kapiattack.ogg")
kapigrabwall = audio_sample_load("Kapigrabwall.ogg")
kapicrashwall = audio_sample_load("Kapicrashwall.ogg")
kapirolling = audio_sample_load("Kapirolling.ogg")

camlock_on = get_texture_info("camlock_on")
kapicamlockon = audio_sample_load("Kapicamlockon.ogg")

camlock_off = get_texture_info("camlock_off")
kapicamlockoff = audio_sample_load("Kapicamlockoff.ogg")

kapiappear = audio_sample_load("Kapiappear.ogg")

kapiattack = audio_sample_load("Kapiattack.ogg")

kapihurt = audio_sample_load("Kapihurt.ogg")

hurtActions = {

    [ACT_SOFT_BACKWARD_GROUND_KB] = true,
    [ACT_BACKWARD_GROUND_KB] = true,
    [ACT_HARD_BACKWARD_GROUND_KB] = true,
    [ACT_BACKWARD_AIR_KB] = true,
    [ACT_HARD_BACKWARD_AIR_KB] = true,
    [ACT_BACKWARD_WATER_KB] = true,
    [ACT_SOFT_FORWARD_GROUND_KB] = true,
    [ACT_FORWARD_GROUND_KB] = true,
    [ACT_HARD_FORWARD_GROUND_KB] = true,
    [ACT_FORWARD_AIR_KB] = true,
    [ACT_HARD_FORWARD_AIR_KB] = true,
    [ACT_FORWARD_WATER_KB] = true,
}

local function on_interact(m, o, intType)
    
    local damagableTypes = (INTERACT_BOUNCE_TOP | INTERACT_BOUNCE_TOP2 | INTERACT_HIT_FROM_BELOW | 2097152 | INTERACT_KOOPA | 
    INTERACT_BREAKABLE | INTERACT_GRABBABLE | INTERACT_BULLY)
  
  m.interactObj = o
  
  if m.action == ACT_KAPI_DASH or m.action == ACT_KAPI_WATER_TURBINE or m.action == ACT_KAPI_ROLL_AIR then
        if (intType & (INTERACT_GRABBABLE) ~= 0) and o.oInteractionSubtype & (INT_SUBTYPE_NOT_GRABBABLE) == 0 then
            m.input = m.input | INPUT_INTERACT_OBJ_GRABBABLE
            if o.oSyncID ~= 0 then
                network_send_object(o, true)
            end
        end
    end

    if ((m.action == ACT_KAPI_ROLL  and (intType & INTERACT_BREAKABLE == 0))
        or m.action == ACT_KAPI_ROLL_FALL or (m.action == ACT_KAPI_KB and m.actionTimer == 1) or (m.action == ACT_KAPI_DASH and (intType & INTERACT_GRABBABLE == 0) ) ) and (intType & damagableTypes) ~= 0 and (m.interactObj.behavior ~= get_behavior_from_id(id_bhvChainChomp) and m.interactObj.behavior ~= get_behavior_from_id(id_bhvBowser)) then
      if intType & INTERACT_GRABBABLE == 0 or m.interactObj.behavior == get_behavior_from_id(id_bhvBobomb) then
        o.oInteractStatus = ATTACK_KICK_OR_TRIP + (INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED)
        else
          o.oInteractStatus = ATTACK_KICK_OR_TRIP + (INT_STATUS_WAS_ATTACKED)
      end
        if m.action ~= ACT_KAPI_KB then
       audio_sample_play(kapiattack, m.pos, 1)
        set_mario_action(m, ACT_KAPI_KB, 0)
        end
      m.particleFlags = m.particleFlags | 0x00040000
        return false
        end
    
    end

function activate_kapi(msg)
  m = gMarioStates[0]
  if msg == '' then
    if gPlayerSyncTable[0].isKapi == true then
      djui_popup_create("\\#ff9090\\You are no longer \\#ffffff\\playing as \\#87889D\\Kapi\\#ffffff\\!", 1)
    gPlayerSyncTable[0].isKapi = false
    play_character_sound(m, CHAR_SOUND_OKEY_DOKEY)
    m.particleFlags = PARTICLE_MIST_CIRCLE
    m.squishTimer = 5
    else
      djui_popup_create("\\#90ff90\\You are now \\#ffffff\\playing as \\#87889D\\Kapi\\#ffffff\\! \n\\#ffffff\\Use /kapi help for the controls!", 2)
    gPlayerSyncTable[0].isKapi = true
    audio_sample_play(kapiappear, m.pos, 1)
    m.particleFlags = PARTICLE_MIST_CIRCLE
    m.squishTimer = 5
    end
        return true
  elseif msg == "help" then
    
    if m.playerIndex == 0 then
      language = smlua_text_utils_get_language()
      end
  
    if language == "Spanish" then
      djui_chat_message_create("Moveset de Kapi's Rock n Roll: \n| (Suelo) A: Salto | (Aire) Mantener A: Girar | (Suelo) Mantener Z: Rodar | (Aire) Mantener Z: Dive | Aterrizar de un Dive en neutro: Ground Pound | (Aire) B: Dash | B > A: Cancelar Dash | Rodar > A en neutro: Salto Alto | Rodar > A: Salto Largo | Dive > A: Boost Resortera | (Pared) A: Walljump | L: Cam-Lock | Puedes agarrar con un Dive o Dash | \nUnderwater: | Joystick: Moverse | A:Subir | Z:Bajar | B:Dash acuatico | B > A/Z:Giro acuatico | Kapi se ahoga más rapido! |")
      else
        djui_chat_message_create("Kapi's Rock n Roll moveset: \n| (Ground) A: Jump | (Air) Hold A: Twirl | (Ground) Hold Z: Roll | (Air) Hold Z: Dive | Land a Dive with neutral Joystick: Pound | (Air) B : Dash | B > A: Dash Cancel | Neutral Roll > A: High Jump | Roll > A: Long Jump | Dive > A: Slingshot Boost | (Wall) A: Walljump | L: Cam-lock | You can grab with a Dive or Dash | \nUnderwater: | Joystick: Move | A:Up | Z:Down | B:Underwater Dash | B > A/Z: Underwater Twirl | You drown quicker as Kapi! |")
end
        return true
  end
  return false
end

function kapi_help_cs(msg)
  m = gMarioStates[0]
  if msg == "help" then
    
    if m.playerIndex == 0 then
      language = smlua_text_utils_get_language()
      end
  
    if language == "Spanish" then
      djui_chat_message_create("Moveset de Kapi's Rock n Roll: \n| (Suelo) A: Salto | (Aire) Mantener A: Girar | (Suelo) Mantener Z: Rodar | (Aire) Mantener Z: Dive | Aterrizar de un Dive en neutro: Ground Pound | (Aire) B: Dash | B > A: Cancelar Dash | Rodar > A en neutro: Salto Alto | Rodar > A: Salto Largo | Dive > A: Boost Resortera | (Pared) A: Walljump | L: Cam-Lock | Puedes agarrar con un Dive o Dash | \nUnderwater: | Joystick: Moverse | A:Subir | Z:Bajar | B:Dash acuatico | B > A/Z:Giro acuatico | Kapi se ahoga más rapido! |")
      else
        djui_chat_message_create("Kapi's Rock n Roll moveset: \n| (Ground) A: Jump | (Air) Hold A: Twirl | (Ground) Hold Z: Roll | (Air) Hold Z: Dive | Land a Dive with neutral Joystick: Pound | (Air) B : Dash | B > A: Dash Cancel | Neutral Roll > A: High Jump | Roll > A: Long Jump | Dive > A: Slingshot Boost | (Wall) A: Walljump | L: Cam-lock | You can grab with a Dive or Dash | \nUnderwater: | Joystick: Move | A:Up | Z:Down | B:Underwater Dash | B > A/Z: Underwater Twirl | You drown quicker as Kapi! |")
end
        return true
  end
  return false
end

CT_KAPI = 0

if _G.charSelectExists then
  
  CT_KAPI = _G.charSelect.character_add(

        "Kapi",

        {
            "It's time to Rock n' Roll!",
            "",
            "Swift cat able to overcome most obstacles he encounters.",
            "Use '/kapi help' for controls",
            "",
            "Kapi's Rock and Roll by Paperkitty."
        },
        "Kristall / Tyluge",
        {r = 127, g = 126, b = 142},
        E_MODEL_KAPI,
        CT_MARIO,
        TEX_HUD_KAPI, 1, -25)

    local PALETTE_KAPI = {
        [PANTS]  = "181820",
        [SHIRT]  = "35a4d7",
        [GLOVES] = "7f7e8e",
        [SHOES]  = "000000",
        [EMBLEM] = "35a4d7",
        [HAIR]   = "222133",
        [SKIN]   = "7f7e8e",
        [CAP]    = "35a4d7",
    }
    
    _G.charSelect.character_add_palette_preset(E_MODEL_KAPI, PALETTE_KAPI)
    
    local VOICETABLE_KAPI = {nil}
    
    _G.charSelect.character_add_voice(E_MODEL_KAPI, VOICETABLE_KAPI)
    
  --_G.charSelect.character_set_category(CT_KAPI, "Roblox 3D platformers.")
    
    if smlua_text_utils_get_language() == "Spanish" then
        hook_chat_command("kapi", "[help] - Un tour rapido de los controles.", kapi_help_cs)
        else
      hook_chat_command("kapi", "[help] - A quick tour on controls.", kapi_help_cs)
      end
    
    else
      
      if smlua_text_utils_get_language() == "Spanish" then
        hook_chat_command("kapi", "[on | off | help] - Activa y desactiva el moveset de Kapi, usa help para aprender los controles.", activate_kapi)
        else
      hook_chat_command("kapi", "[on | off | help] - Toggles Kapi's Moveset, use help to learn the controls.", activate_kapi)
      end

  end

camlock_on = get_texture_info("camlock_on")

camlock_off = get_texture_info("camlock_off")
if smlua_text_utils_get_language() == "Spanish" then 
  commandhelp = "[on | off | help] - Activa o desactiva el moveset de kapi, usa help para aprender los controles." else
    commandhelp = "[on | off | help] - Toggles Kapi's Moveset, use help to learn the controls."
end

function open_doors_you_fat_cat(m)
  
    local dist = 150
    local doorwarp = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvDoorWarp)
    local door = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvDoor)
    local stardoor = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvStarDoor)
    local shell = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvKoopaShell)
    
    if m.action == ACT_WALKING or m.action == ACT_HOLD_WALKING then
        if
        ((doorwarp ~= nil and dist_between_objects(m.marioObj, doorwarp) > dist) or
        (door ~= nil and dist_between_objects(m.marioObj, door) > dist) or
        (stardoor ~= nil and dist_between_objects(m.marioObj, stardoor) > dist) or (dist_between_objects(m.marioObj, shell) > dist and shell ~= nil) and m.heldObj == nil)
        then
            return set_mario_action(m, ACT_KAPI_WALKING, 0)
        elseif doorwarp == nil and door == nil and stardoor == nil and shell == nil then
            return set_mario_action(m, ACT_KAPI_WALKING, 0)
        end
    end
    
    if m.action == ACT_KAPI_WALKING then
        if
        (dist_between_objects(m.marioObj, doorwarp) < dist and doorwarp ~= nil) or
        (dist_between_objects(m.marioObj, door) < dist and door ~= nil) or
        (dist_between_objects(m.marioObj, stardoor) < dist and stardoor ~= nil) or (dist_between_objects(m.marioObj, shell) < dist and shell ~= nil)
        then
          if m.heldObj == nil then
            return set_mario_action(m, ACT_WALKING, 0)
            else
              return set_mario_action(m, ACT_HOLD_WALKING, 0)
              end
        
    end
end
end
  

local function on_hud_render()
  m = gMarioStates[0]
  local e = gStateExtras[gMarioStates[0].playerIndex]
  local djuiheight = djui_hud_get_screen_height()
  local camlock = e.camLock == true and camlock_on or e.camLock == false and camlock_off
  
  if m.playerIndex == 0 then
  if gPlayerSyncTable[0].isKapi == true or (_G.charSelectExists and CT_KAPI == _G.charSelect.character_get_current_number() ) then
    djui_hud_render_texture(camlock, 16, djuiheight - 94, 1.25, 1.25)
end
end
end

local function mario_update(m)
  local e = gStateExtras[m.playerIndex]
  
  local language = smlua_text_utils_get_language()
  
  if m.forwardVel > 80 and (m.action == ACT_KAPI_ROLL or m.action == ACT_KAPI_ROLL_FALL or m.action == ACT_KAPI_LONG_JUMP or m.action == ACT_KAPI_TWIRL) then
        m.particleFlags = PARTICLE_SPARKLES
    end
  
  if m.playerIndex == 0 then
  if gPlayerSyncTable[0].isKapi == true or (_G.charSelectExists and CT_KAPI == _G.charSelect.character_get_current_number() ) then
    
    open_doors_you_fat_cat(m)
    
    if m.action == ACT_GROUND_POUND_LAND then
      if m.controller.buttonPressed & A_BUTTON ~= 0 then
      set_mario_action(m, ACT_KAPI_HIGH_JUMP, 0)
      end
      end
    
    if m.hurtCounter > 0 and gPlayerSyncTable[0].CanHurtSound == true then
      audio_sample_play(kapihurt, m.pos, 2)
      gPlayerSyncTable[0].CanHurtSound = false
      elseif m.hurtCounter == 0 then
        gPlayerSyncTable[0].CanHurtSound = true
      end

    if m.controller.buttonPressed & L_TRIG ~= 0 then
      e.camLock = not e.camLock
      
     if e.camLock == true then
       audio_sample_play(kapicamlockon, m.pos, 2.5)
       if not camera_config_is_mouse_look_enabled() then
         djui_popup_create("Mouselook is recommended for Cam-Lock! Options > Camera > Free Camera > Mouselook", 3)
         end
       else
         audio_sample_play(kapicamlockoff, m.pos, 2.5)
         end
      
    end

    
  if m.action ==
  ACT_KAPI_WALKING or m.action ==
  ACT_IDLE or m.action ==
  ACT_PANTING or m.action == ACT_START_CROUCHING or m.action & ACT_FLAG_BUTT_OR_STOMACH_SLIDE ~= 0 then 
    if m.controller.buttonDown & Z_TRIG ~= 0 and is_game_paused() == 0 then
      if m.action & ACT_FLAG_AIR == 0 and m.heldObj == nil and not m.wall then
    set_mario_action(m, ACT_KAPI_ROLL, 0)
    m.particleFlags = PARTICLE_MIST_CIRCLE | PARTICLE_VERTICAL_STAR
    mario_set_forward_vel(m, 55)
    end
    end
end

if m.action == ACT_KAPI_JUMP or
m.action == ACT_KAPI_DASH or
m.action == ACT_WALL_KICK_AIR or
(m.action == ACT_KAPI_LONG_JUMP or
m.action == ACT_KAPI_AIRJUMP) and m.actionTimer > 2 or m.action == ACT_KAPI_HIGH_JUMP and m.actionTimer > 5 or
m.action == ACT_KAPI_FREEFALL or
m.action == ACT_KAPI_DASH_CANCEL or
m.action == ACT_KAPI_WATER_JUMP or
(m.action == ACT_KAPI_KB and m.actionTimer > 5) or
m.action == ACT_FLYING
or m.action & ACT_FLAG_BUTT_OR_STOMACH_SLIDE ~= 0 then
if m.action & ACT_FLAG_AIR ~= 0 then
  if m.controller.buttonPressed & Z_TRIG ~= 0 and m.heldObj == nil then
    set_mario_action(m, ACT_KAPI_ROLL_AIR, 0)
end
end
end

if (m.action == ACT_KAPI_JUMP or m.action == ACT_WALL_KICK_AIR) and m.vel.y < -1 then set_mario_action(m, ACT_KAPI_FREEFALL, 0)
  end

if (m.action == ACT_KAPI_JUMP and m.actionTimer > 1) or
m.action == ACT_KAPI_LONG_JUMP or
m.action == ACT_KAPI_HIGH_JUMP or
m.action == ACT_WALL_KICK_AIR or
m.action == ACT_KAPI_DASH_CANCEL or
m.action == ACT_KAPI_AIR_JUMP or
m.action == ACT_KAPI_FREEFALL then
if m.action & ACT_FLAG_AIR ~= 0 then
  if m.controller.buttonPressed & A_BUTTON ~= 0 and m.action ~= ACT_KAPI_TWIRL then
    if m.actionTimer >= 3 then
      e.twirlMomentum = m.forwardVel
    set_mario_action(m, ACT_KAPI_TWIRL, 0)
    if m.prevAction == ACT_KAPI_AIR_JUMP then
      gPlayerSyncTable[0].ACT_FLAG_CAN_ROLL_VARIATE = 0
      end
    end
  end
end
end
  
  if m.action ==
  ACT_KAPI_JUMP or m.action ==
  ACT_WALL_KICK_AIR or m.action == ACT_KAPI_HIGH_JUMP or m.action == ACT_KAPI_LONG_JUMP or m.action == ACT_SOFT_BONK or m.action == ACT_KAPI_AIR_JUMP or m.action == ACT_KAPI_FREEFALL or m.action ==
  ACT_KAPI_WATER_JUMP then
    if m.controller.buttonPressed & B_BUTTON ~= 0 and gPlayerSyncTable[0].ACT_FLAG_CAN_DASH ~= 0 and m.heldObj == nil then
      set_mario_action(m, ACT_KAPI_DASH, 0)
      gPlayerSyncTable[0].ACT_FLAG_CAN_DASH = 0
    end
  end
  
  if m.action == ACT_KAPI_DASH then
    if m.controller.buttonPressed & A_BUTTON ~= 0 and m.actionTimer < 20 and m.heldObj == nil and gPlayerSyncTable[0].KAPI_WALLJUMP_COUNTER < 7 then
      set_mario_action(m, ACT_KAPI_DASH_CANCEL, 0)
    end
    end
    
 
  if m.action == ACT_KAPI_ROLL or m.action == ACT_KAPI_ROLL_FALL then
    if m.controller.buttonPressed & A_BUTTON ~= 0 and m.controller.stickMag == 0 then
      set_mario_action(m, ACT_KAPI_HIGH_JUMP, 0)
      audio_sample_stop(kapirolling)
      m.forwardVel = 0
      m.vel.y = 65
    elseif m.controller.buttonPressed & A_BUTTON ~= 0 and m.controller.stickMag > 0 then
      set_mario_action(m, ACT_KAPI_LONG_JUMP, 0)
      audio_sample_stop(kapirolling)
      m.forwardVel = m.forwardVel/1.3
      m.vel.y = 55
    end
  end
  
  if m.action ~= ACT_KAPI_ROLL and m.prevAction == ACT_KAPI_ROLL then
    audio_sample_stop(kapirolling)
    end
  
  if m.action == ACT_KAPI_ROLL_AIR then
    if m.controller.buttonPressed & A_BUTTON ~= 0 and gPlayerSyncTable[0].ACT_FLAG_CAN_ROLL_VARIATE ~= 0 then
      set_mario_action(m, ACT_KAPI_AIR_JUMP, 0)
      gPlayerSyncTable[0].ACT_FLAG_CAN_ROLL_VARIATE = 0
      m.forwardVel = m.forwardVel / 8
      m.vel.y = 65
  end
  end

  if m.wall and m.action & ACT_FLAG_SWIMMING == 0 and m.action & ACT_FLAG_AIR ~= 0 and m.health > 0x100 then
    if m.action ~= ACT_KAPI_WALL and m.action ~= ACT_SHOT_FROM_CANNON and m.action ~= ACT_FLYING and m.action ~= ACT_EMERGE_FROM_PIPE and m.action ~= ACT_KAPI_KB and m.action ~= ACT_RIDING_SHELL_JUMP and m.heldObj == nil then
      audio_sample_play(kapigrabwall, m.pos, 2.5)
                set_mario_action(m, ACT_KAPI_WALL, 0)
                gPlayerSyncTable[0].KAPI_WALLJUMP_COUNTER = gPlayerSyncTable[0].KAPI_WALLJUMP_COUNTER + 1
                
                m.particleFlags = PARTICLE_MIST_CIRCLE
                else
                  return
    end
end

if (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED and m.flags & MARIO_METAL_CAP == 0 then
m.health = m.health - 2
end

if e.camLock == true then
  
  camera_config_enable_centering(false)
  
  if m.action ~= ACT_KAPI_TWIRL and
  m.action ~= ACT_KAPI_AIR_JUMP and
  m.action ~= ACT_KAPI_DASH_CANCEL and
  m.action ~= ACT_KAPI_WATER_JUMP and
  m.action ~= ACT_KAPI_WALL and
  m.action ~= ACT_HOLDING_BOWSER and 
  m.action ~= ACT_RELEASING_BOWSER and
  m.action ~= ACT_FLYING and
  m.action ~= ACT_KAPI_TURBINE_CANCEL then
    m.marioObj.header.gfx.angle.y = gLakituState.yaw + 0x8000
  end
end
  
  m.peakHeight = m.pos.y
  
  if m.flags & MARIO_METAL_CAP ~= 0 then
    if m.action ~= ACT_KAPI_DASH then
      m.vel.y = m.vel.y - 1.5
      if m.controller.stickMag > 0 and m.forwardVel < 55 and m.action ~= ACT_METAL_WATER_JUMP then
        mario_set_forward_vel(m, m.forwardVel + 2.5)
        end
    end
    end
  elseif m.flags & MARIO_VANISH_CAP ~= 0 then
      m.vel.y = m.vel.y + 1.6
      if m.controller.stickMag > 0 and m.forwardVel > 55 then
      m.forwardVel = m.forwardVel - 5
    end
end
  
  if m.controller.stickMag == 0 and m.forwardVel > 0 and (m.action ~= ACT_FLYING and m.action ~= ACT_KAPI_ROLL and m.action ~= ACT_KAPI_ROLL_FALL) then
    m.forwardVel = m.forwardVel - 1.1
  end
  
  if m.controller.stickMag ~= 0 and m.forwardVel < 35 and (m.action == ACT_KAPI_JUMP or m.action == ACT_KAPI_FREEFALL) then
    m.forwardVel = m.forwardVel + 2.5
  end
     
     else
end
end

local function attackThing(m, obj)
  
  if m.playerIndex == 0 then
  if gPlayerSyncTable[0].isKapi == true or (_G.charSelectExists and CT_KAPI == _G.charSelect.character_get_current_number() ) then
    if m.action == ACT_KAPI_ROLL or
    m.action == ACT_KAPI_ROLL_FALL or
    m.action == ACT_KAPI_ROLL_AIR or
    m.action == ACT_KAPI_DASH then
      audio_sample_play(kapiattack, m.pos, 1)
    set_mario_action(m, ACT_KAPI_KB, 0)
    end
  end
  end
  end

local function attackPlayer(m, obj)
  
  if m.playerIndex == 0 then
  if gPlayerSyncTable[0].isKapi == true or (_G.charSelectExists and CT_KAPI == _G.charSelect.character_get_current_number() ) then
    if obj.action & ACT_FLAG_ATTACKING == 0 then
    if m.action == ACT_KAPI_ROLL or
    m.action == ACT_KAPI_ROLL_FALL or
    m.action == ACT_KAPI_ROLL_AIR or
    m.action == ACT_KAPI_DASH then
      audio_sample_play(kapiattack, m.pos, 1)
    set_mario_action(m, ACT_KAPI_KB, 0)
    set_mario_action(obj, ACT_HARD_FORWARD_AIR_KB, 0)
    obj.hurtCounter = 6
    return true
    elseif obj.action & ACT_FLAG_ATTACKING ~= 0 and m.action & ACT_FLAG_ATTACKING == 0 then audio_sample_play(kapihurt, m.pos, 1)
    set_mario_action(m, ACT_KAPI_HURT, 0)
    m.faceAngle.y = obj.faceAngle.y
    m.squishTimer = 10
      else
      return false
    end
  end
  end
  end
  end

local function on_set_mario_action(m)
  
  if m.playerIndex == 0 then
    if gPlayerSyncTable[0].isKapi == true or (_G.charSelectExists and CT_KAPI == _G.charSelect.character_get_current_number() ) then
  if m.action == ACT_KAPI_ROLL_AIR and m.controller.buttonPressed & A_BUTTON ~= 0 then
    if m.action & ACT_FLAG_AIR ~= 0 then
      gPlayerSyncTable[0].ACT_FLAG_CAN_ROLL_VARIATE = 0
    end
  end
  
  if m.action & ACT_GROUP_MASK == ACT_GROUP_SUBMERGED and m.action ~= ACT_KAPI_SWIM_IDLE then
    if (m.action ~= ACT_BACKWARD_WATER_KB and m.action ~= ACT_KAPI_WATER_TURBINE and m.action ~= ACT_KAPI_TURBINE_CANCEL and m.action ~= ACT_KAPI_WATER_KB and m.action ~= ACT_DROWNING) and m.flags & MARIO_METAL_CAP == 0 then
      vec3f_set(m.marioBodyState.headAngle, 0x0, 0, 0)
    set_mario_action(m, ACT_KAPI_SWIM_IDLE, 0)
    m.particleFlags = m.particleFlags | PARTICLE_WATER_SPLASH
    play_sound(SOUND_OBJ_DIVING_INTO_WATER, m.marioObj.header.gfx.cameraToObject)
    end
  end
  
  if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_LONG_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_STEEP_JUMP or m.action == ACT_WATER_JUMP then
      set_mario_action(m, ACT_KAPI_JUMP, 0)
  end
  
  if hurtActions[m.action] and m.hurtCounter > 0 and m.health >= 0x100 then
        if m.pos.y + m.vel.y > m.waterLevel - 80 then
            set_mario_action(m, ACT_KAPI_HURT, 0)
        else
            set_mario_action(m, ACT_KAPI_WATER_KB, 0)
            mario_set_forward_vel(m, -35)
        end
    end
  
  if (m.action & ACT_FLAG_AIR == 0 or m.action == ACT_KAPI_WALL) and m.playerIndex == 0 then
     gPlayerSyncTable[0].ACT_FLAG_CAN_DASH = 1
  end
  if m.action & ACT_FLAG_AIR == 0 and m.playerIndex == 0 then
    gPlayerSyncTable[0].ACT_FLAG_CAN_ROLL_VARIATE = 1
    gPlayerSyncTable[0].ACT_FLAG_TWIRL_BOOST = 1
gPlayerSyncTable[0].KAPI_WALLJUMP_COUNTER = 0
    end
   
    end
end
end

function before_set_mario_action(m, nextAct)
  if m.playerIndex == 0 then
    if gPlayerSyncTable[0].isKapi == true or (_G.charSelectExists and CT_KAPI == _G.charSelect.character_get_current_number() ) then
  if nextAct == ACT_DIVE or
  nextAct == ACT_PUNCHING or
  nextAct == ACT_MOVE_PUNCHING or
  nextAct == ACT_CROUCH_SLIDE or
  nextAct == ACT_SLIDE_KICK then
    return 1
  end
  
  if nextAct == ACT_FREEFALL then
    return ACT_KAPI_FREEFALL
  end
  
  if nextAct == ACT_HOLD_JUMP then
    return ACT_KAPI_JUMP
    end
  
  if nextAct == ACT_GROUND_POUND then
   return ACT_KAPI_ROLL_AIR
  end
  
  if nextAct == ACT_START_CROUCHING then
    return ACT_KAPI_ROLL
    end
  
    end
end
end

hook_event(HOOK_BEFORE_SET_MARIO_ACTION, before_set_mario_action)
hook_event(HOOK_OBJECT_SET_MODEL, function(obj, model)
  local m = gMarioStates[network_local_index_from_global(obj.globalPlayerIndex)]
  
  local charmodels = {
    
    [E_MODEL_MARIO] = true,
    [E_MODEL_LUIGI] = true,
    [E_MODEL_TOAD_PLAYER] = true,
    [E_MODEL_WARIO] = true,
    [E_MODEL_WALUIGI] = true

  }

if gPlayerSyncTable[network_local_index_from_global(obj.globalPlayerIndex)].isKapi == true then
  if m.character.type ~= CT_MARIO then
          gNetworkPlayers[network_local_index_from_global(obj.globalPlayerIndex)].overrideModelIndex = CT_MARIO
  end
      end

        if get_id_from_behavior(obj.behavior) ~= id_bhvMario then return end

          if charmodels[model] and gPlayerSyncTable[network_local_index_from_global(obj.globalPlayerIndex)].isKapi == true then
            return obj_set_model_extended(obj, E_MODEL_KAPI)
          end
    end)

function on_mod_loaded()
  if _G.charSelectExists then
  _G.charSelect.config_character_sounds()
  else
  end
  end

  hook_event(HOOK_MARIO_UPDATE, mario_update)
  hook_event(HOOK_ON_SET_MARIO_ACTION, on_set_mario_action)
  hook_event(HOOK_ON_ATTACK_OBJECT, attackThing)
  hook_event(HOOK_ALLOW_PVP_ATTACK, attackPlayer)
  hook_event(HOOK_ON_HUD_RENDER_BEHIND, on_hud_render)
  hook_event(HOOK_ON_INTERACT, on_interact)
  hook_event(HOOK_ON_MODS_LOADED, on_mod_loaded)