ACT_KAPI_SWIM_IDLE = allocate_mario_action(ACT_FLAG_METAL_WATER | ACT_GROUP_SUBMERGED | ACT_FLAG_WATER_OR_TEXT)

ACT_KAPI_WATER_JUMP = allocate_mario_action(ACT_FLAG_MOVING | ACT_GROUP_AIRBORNE | ACT_FLAG_AIR)

ACT_KAPI_WATER_TURBINE = allocate_mario_action(ACT_FLAG_ATTACKING | ACT_GROUP_SUBMERGED | ACT_FLAG_WATER_OR_TEXT | ACT_FLAG_METAL_WATER)

ACT_KAPI_TURBINE_CANCEL = allocate_mario_action(ACT_FLAG_ATTACKING | ACT_GROUP_SUBMERGED | ACT_FLAG_WATER_OR_TEXT | ACT_FLAG_METAL_WATER)

ACT_KAPI_WATER_KB = allocate_mario_action(ACT_GROUP_SUBMERGED | ACT_FLAG_INVULNERABLE | ACT_FLAG_METAL_WATER | ACT_FLAG_WATER_OR_TEXT)

local kapiwaterjump = audio_sample_load("Kapiwaterjump.ogg")

local s16 = function(x)

    x = (math.floor(x) & 0xFFFF)

    if x >= 32768 then return x - 65536 end
    return x
end

local function act_kapi_swim_idle(m)
  
  local Mag = (m.controller.stickMag)/64
  
  local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)
  
  if m.health < 254 then
    set_mario_action(m, ACT_DROWNING, 0)
  end
  if m.playerIndex == 0 then
  audio_sample_stop(kapirolling)
  end
  
  if Mag > 0 or (m.controller.buttonDown & A_BUTTON ~= 0 or m.controller.buttonDown & Z_TRIG ~= 0) then
set_mario_anim_with_accel(m, CHAR_ANIM_FLUTTERKICK, m.forwardVel*0x1000)
  else
 set_mario_animation(m, CHAR_ANIM_WATER_IDLE)
  end
  
   if m.pos.y <= m.floorHeight and m.vel.y <= 0 then
        step = perform_ground_step(m)
    else
        step = perform_air_step(m, 0)
   end

  if (m.controller.buttonDown & Z_TRIG ~= 0) then
    m.vel.y = approach_s32(m.vel.y, -35, 3.5, 4.5)
  if Mag == 0 then
    set_mario_anim_with_accel(m, CHAR_ANIM_FLUTTERKICK, (-1*m.vel.y*0x1500))
 end
    m.marioObj.header.gfx.angle.x = m.marioObj.header.gfx.angle.x + 0x1000
   
  elseif m.controller.buttonDown & A_BUTTON ~= 0 then
    if m.pos.y >= m.waterLevel - 100 then
      set_mario_action(m, ACT_KAPI_WATER_JUMP, 0)
    end
    m.vel.y = approach_s32(m.vel.y, 20, 3, 3.5)
  if Mag == 0 then  
    set_mario_anim_with_accel(m, CHAR_ANIM_FLUTTERKICK, m.vel.y*0x1500)
 end  
   m.marioObj.header.gfx.angle.x = m.marioObj.header.gfx.angle.x - 0x1000
    
    else
      if m.vel.y < 0 then
      m.vel.y = m.vel.y + 1.25
      end
  m.marioObj.header.gfx.angle.x = 0x0
  end
      m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x500, 0x500)
    
    if m.controller.buttonPressed & B_BUTTON ~= 0 then
          set_mario_action(m, ACT_KAPI_WATER_TURBINE, 0)
    end
        
        set_swimming_at_surface_particles(m, PARTICLE_WAVE_TRAIL)
      
      if Mag ~= 0 or (m.controller.buttonDown & A_BUTTON ~= 0 or m.controller.buttonDown & Z_TRIG ~= 0) then
        if m.forwardVel < Mag*35 then
          mario_set_forward_vel(m, m.forwardVel + 1)
            else
     mario_set_forward_vel(m, m.forwardVel - 2.5)
          end
        if is_anim_past_end(m) ~= 0 then
    play_sound(SOUND_ACTION_SWIM_FAST, m.marioObj.header.gfx.cameraToObject)
                    set_mario_particle_flags(m, PARTICLE_PLUNGE_BUBBLE, 0)
    end
        else
          if m.forwardVel > 0 then
            mario_set_forward_vel(m, m.forwardVel - 2.5)
            else
              mario_set_forward_vel(m, m.forwardVel + 1)
          end
      end

end

local function act_kapi_water_jump(m)
  local e = gStateExtras[m.playerIndex]
  
  local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)
  
  if m.actionTimer == 0 then
    audio_sample_play(kapiwaterjump, m.pos , 0.5)
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE | PARTICLE_WATER_SPLASH
    m.squishTimer = 5
    play_sound(SOUND_OBJ_DIVING_INTO_WATER, m.marioObj.header.gfx.cameraToObject)
    e.rotAngle = 0x0
    m.vel.y = 55
  end
  mario_set_forward_vel(m, approach_s32(m.forwardVel, (m.controller.stickMag/64)*60, 2.5, 2.5))
  common_air_action_step(m, ACT_JUMP_LAND, CHAR_ANIM_TRIPLE_JUMP, AIR_STEP_NONE)
  
  if ACT_FLAG_CAM_LOCK == true then
    m.faceAngle.y = gLakituState.yaw + 0x8000
    else
  m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x500, 0x500)
 end
  
 if e.rotAngle < 0x10216 then
 e.rotAngle = e.rotAngle + 0x1024
   else
     end
  
   m.marioObj.header.gfx.angle.z = m.marioObj.header.gfx.angle.z + e.rotAngle
  
  m.actionTimer = m.actionTimer + 1
  return
end



local function act_kapi_water_turbine(m)
  local e = gStateExtras[m.playerIndex]
  
  local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)
  
  if m.actionTimer == 0 then
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE | PARTICLE_VERTICAL_STAR
    m.squishTimer = 5
    e.rotAngle = 0x0
    play_sound(SOUND_ACTION_SWIM_FAST, m.marioObj.header.gfx.cameraToObject)
  end
  
  set_mario_animation(m, CHAR_ANIM_SLIDE_DIVE)
  m.particleFlags = m.particleFlags | PARTICLE_PLUNGE_BUBBLE
  
  
  
  if m.controller.buttonDown & A_BUTTON ~= 0 then
    set_mario_action(m, ACT_KAPI_TURBINE_CANCEL, 1)
    m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
    m.squishTimer = 5
  elseif m.controller.buttonDown & Z_TRIG ~= 0 then
    m.squishTimer = 5
    set_mario_action(m, ACT_KAPI_TURBINE_CANCEL, 0)
    m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
  else
    m.vel.y = 0
    mario_set_forward_vel(m, 40)
    m.marioObj.header.gfx.angle.x = 0x0
    end
  
  if m.pos.y <= m.floorHeight and m.vel.y <= 0 then
        step = perform_ground_step(m)
    else
        step = perform_air_step(m, 0)
  end
  
  if e.rotAngle > 0x10216 then
    e.rotAngle = 0x0 else
      e.rotAngle = e.rotAngle + 0x2048
  end
    m.marioObj.header.gfx.angle.z = e.rotAngle
    
    if e.camLock == false then
    m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x250, 0x250)
    else
    m.faceAngle.y = gLakituState.yaw + 0x8000
    end
    
  if step == AIR_STEP_HIT_WALL or step == GROUND_STEP_HIT_WALL then
    set_mario_action(m, ACT_KAPI_WATER_KB, 0)
    mario_set_forward_vel(m, -30)
    m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
    audio_sample_play(kapicrashwall, m.pos, 1)
    m.squishTimer = 10
    end
  
  if m.actionTimer == 14 then
    set_mario_action(m, ACT_KAPI_SWIM_IDLE, 0)
    end
  
  m.actionTimer = m.actionTimer + 1
  
end

local function act_kapi_turbine_cancel(m)
  local e = gStateExtras[m.playerIndex]
  
  perform_air_step(m, 0)
  
  if m.actionTimer < 3 then
    m.vel.y = 0
    mario_set_forward_vel(m, approach_s32(m.forwardVel, 0, 5, 5))
    e.rotAngle = 0
    else
     if m.actionArg == 1 then
       m.vel.y = 35
     elseif m.actionArg == 0 then
       m.vel.y = -45
     end
     end
  set_mario_animation(m, CHAR_ANIM_TWIRL)
  m.marioObj.header.gfx.angle.y = e.rotAngle
  
  if m.pos.y >= m.waterLevel - 100 then
      set_mario_action(m, ACT_KAPI_WATER_JUMP, 0)
   audio_sample_play(kapiwaterjump, m.pos , 0.5)
    m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE | PARTICLE_WATER_SPLASH
    m.squishTimer = 5
    play_sound(SOUND_OBJ_DIVING_INTO_WATER, m.marioObj.header.gfx.cameraToObject)
    e.rotAngle = 0x0
    m.vel.y = 55
    end
  
  e.rotAngle = e.rotAngle + 0x2500
  if e.rotAngle > 0x16000 then
    e.rotAngle = e.rotAngle - 0x16000
  end
  if m.actionTimer > 11 then
    set_mario_action(m, ACT_KAPI_SWIM_IDLE, 0)
    end
  
  m.actionTimer = m.actionTimer + 1
end

local function act_kapi_water_kb(m)
  local e = gStateExtras[m.playerIndex]
  
  local intendedYawbutcoolig = s16(m.intendedYaw - m.faceAngle.y)
  
  perform_air_step(m, 0)
  
  m.vel.y = approach_s32(m.vel.y, 0, 2.5, 2.5)
  
  set_mario_anim_with_accel(m, CHAR_ANIM_BACKWARDS_WATER_KB, 0x2500*(m.forwardVel*-1))
  
  if e.camLock == false then
  m.faceAngle.y = m.intendedYaw - approach_s32(intendedYawbutcoolig, 0, 0x500, 0x500)
  else
    m.faceAngle.y = gLakituState.yaw + 0x8000
    end
  
  if m.actionTimer > 10 then
    set_mario_action(m, ACT_KAPI_SWIM_IDLE, 0)
  end
  
  m.actionTimer = m.actionTimer + 1
    end

hook_mario_action(ACT_KAPI_SWIM_IDLE, act_kapi_swim_idle)
hook_mario_action(ACT_KAPI_WATER_JUMP, act_kapi_water_jump)
hook_mario_action(ACT_KAPI_WATER_TURBINE, act_kapi_water_turbine)
hook_mario_action(ACT_KAPI_TURBINE_CANCEL, act_kapi_turbine_cancel)
hook_mario_action(ACT_KAPI_WATER_KB, act_kapi_water_kb)